Bug 465159

Summary: Review Request: tcexam - A Web-based Computer-Based Assessment (CBA) software
Product: [Fedora] Fedora Reporter: Oron Peled <oron>
Component: Package ReviewAssignee: Nobody's working on this, feel free to take it <nobody>
Status: CLOSED NOTABUG QA Contact: Fedora Extras Quality Assurance <extras-qa>
Severity: medium Docs Contact:
Priority: medium    
Version: rawhideCC: aquini, fedora-package-review, notting
Target Milestone: ---   
Target Release: ---   
Hardware: All   
OS: Linux   
Whiteboard:
Fixed In Version: Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2010-08-07 11:01:05 EDT Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Bug Depends On:    
Bug Blocks: 201449    

Description Oron Peled 2008-10-01 16:46:11 EDT
Spec URL: http://oron.fedorapeople.org/tcexam/tcexam.spec
SRPM URL: http://oron.fedorapeople.org/tcexam/tcexam-5.4.006-1.fc8.src.rpm
Description:
  TCExam is a free Web-based and Open-Source Computer-Based Assessment
  (CBA) software application hosted on the SourceForge.net repository.
  TCExam is divided in two main sections: Public and Administration.

Since the only packaging policy for web-applications refer to their
location (/usr/share/app-name and not /var/www/app-name), I had to
make several decisions -- So the current package is used by me to
validate/correct these assumptions as well.

Packaging overview:
 1. Created selinux sub-package.
 2. The application needs an instantiated database (either MySQL or Postgresql):
    a. Each database type is a sub-package, containing the init data.
    b. Since RPM installs are not interactive, I added a script that can
       create/init/drop the database (currently only MySQL implemented fully).
    c. This script is installed in sbindir (better suggestion?)
    d. The init data is in /usr/share/tcexam/setup (didn't have better place).
 3. The php application have some scripts that embed configuration variables:
    a. For now, they are located as upstream put them (not in /etc).
    b. They are mod 0440 because some of them contain sensitive info
       (e.g: the database password).
    c. Therefore, they are owned by apache (so the web-app can access them)
       The apache user is created by httpd which is one of the depndencies
       of our package anyway.
 4. The upstream package host its logs under the application directory:
    a. I fixed them to /var/log/tcexam/tce.log
    b. Added a logrotate config.
 5. Likewise, I moved cached files to /var/cache/tcexam.
 6. There wasn't any suitable Group. I used Applications/Web (shouldn't we
    have a group for these apps?)
 7. The application is bundled with tcpdf.org which is itself a FOSS project
    (by the same upstream author). This should probably be refactored as
    a separate package (later).
 8. For tcpdf, there are some bundled fonts (dejavu and freefont). While they
    look free. I'll have to check with upstream how can we use existing
    system fonts (maybe by linking).
Comment 1 Oron Peled 2008-12-08 14:37:32 EST
Spec URL: http://oron.fedorapeople.org/tcexam/tcexam.spec
SRPM URL: http://oron.fedorapeople.org/tcexam/tcexam-7.0.006-1.fc10.src.rpm

* Bumped to upstream version 7.0.006
* Better configuration via included tcexam-setdef script
  (used both during build and in post-install).
* Included Hebrew support patch + translation (sent and accepted
  by upstream, patch should be removed on next release).
Comment 2 Jason Tibbitts 2009-11-12 19:50:41 EST
Wow, this is ancient.  Are you still interested in contributing this package?  If so, here are a few comments:

I note that the current version has a significantly larger version number, which is not surprising.

The selinux subpackage is going to be scary for most reviewers; I certainly don't feel qualified to review it.  Have the selinux folks (dwalsh, etc.) had a look at your policy?

I have significant doubts about files in /usr/share being configuration files.

Group is completely unimportant; put whatever you want there.  The proper way to classify such applications is using comps.

If tcpdf.org is actually a separate package (separate tarball, differing release cycle), it cannot be bundled as part of this one.

The fonts cannot be bundled; they must be packaged (if they aren't already) and the code must use the packaged versions.

Don't try to output information in scriptlets; you can't expect that it will be seen by anyone.
Comment 3 Oron Peled 2009-11-14 19:39:17 EST
> Wow, this is ancient.  Are you still interested in contributing this package?
Yes, I am. I rebuilt an updated package, NOT to be pushed to Fedora as is,
but to be used as a working reference while we work on resolving the
different issues. It is located in:
SPEC: http://oron.fedorapeople.org/tcexam/tcexam.spec
SRPM: http://oron.fedorapeople.org/tcexam/tcexam-9.0.035-1.fc11.src.rpm

Work plan:
 * Package tcpdf.org:
   - Font issues -- started with Fedora font SIG:
      https://www.redhat.com/archives/fedora-fonts-list/2009-November/msg00013.html
   - Maybe need to package ttf2ufm and/or afm2pfm
   - Coordinate with moodle packager. During my search for ttf2ufm upstream
     I found that tcpdf and its fonts are bundled with moodle (including
     in the Fedora package :-O
 * Verify selinux policy with dwalsh
 * Finally package tcexam.org itself.

Can you review all this stuff, step by step, as I move along?
 - If yes, I will start working on the items. For every new
   package needed, I will add here a link to its bug report
   so you can easily find them.
 - If you do not have the time for this, I will regretfully have to
   return to my numb mode until someone find this bug report...

Thanks,
Comment 4 Jason Tibbitts 2009-11-19 21:40:36 EST
I'm willing to answer questions if you ask and I actually understand enough to answer, but I'm not sure there's any point in anyone reviewing this package until the known issues are closer to being fixed.

The moodle problem is indeed an issue; it might have been missed on review, or it might have been added after review.  Regardless, tcpdf should certainly be split out so that both packages can use it.
Comment 5 Rafael Aquini 2010-07-30 22:58:27 EDT
PING

It's been almost ten months with no progress; This bug should be closed soon if
there is no response, shouldn't it?
Comment 6 Rafael Aquini 2010-08-07 11:01:05 EDT
Due to the lack of response, this review is now considered as stalled.
I'm closing this bug just as described in Fedora's Policy for stalled package
reviews

http://fedoraproject.org/wiki/Policy_for_stalled_package_reviews
Comment 7 Oron Peled 2010-08-07 13:40:50 EDT
That's OK on my part. If/when I have more time, I'll try to refactor
tcpdf which is the real blocker here. Until than please note that
moodle (which is packaged in Fedora) carries a private copy of tcpdf
just like tcexam -- which is definitely contra Fedora policies... :-(